
Option Strict On
Option Explicit On

Imports FarPoint.Win.Spread

Public Class Form1

    Public Const DOWNLOAD_ORDER_ID_COL As Int32 = 0
    Public Const DOWNLOAD_ORDER_PRINT_LOCATION_ID_COL As Int32 = 1
    Public Const DOWNLOAD_ORDER_NUMBER_COL As Int32 = 2
    Public Const DOWNLOAD_ORDER_NAME_COL As Int32 = 3
    Public Const DOWNLOAD_ORDER_LIBRARY_ID_COL As Int32 = 4
    Public Const DOWNLOAD_ORDER_LIBRARY_COL As Int32 = 5
    Public Const DOWNLOAD_ORDER_PRINT_LOCATION_COL As Int32 = 6
    Public Const DOWNLOAD_ORDER_STATUS_ID_COL As Int32 = 7
    Public Const DOWNLOAD_ORDER_STATUS_COL As Int32 = 8
    Public Const DOWNLOAD_ORDER_MESSAGE_COL As Int32 = 9
    Public Const DOWNLOAD_ORDER_MAX_COLS As Int32 = 9

    Public Const DOWNLOAD_ITEM_QUEUE_ID_COL As Int32 = 0
    Public Const DOWNLOAD_ITEM_ORDER_ITEM_ID_COL As Int32 = 1
    Public Const DOWNLOAD_ITEM_PRODUCTION_COMPONENT_ID_COL As Int32 = 2
    Public Const DOWNLOAD_ITEM_ORDER_ID_COL As Int32 = 3
    Public Const DOWNLOAD_ITEM_LIBRARY_ID_COL As Int32 = 4
    Public Const DOWNLOAD_ITEM_DISPLAY_NAME_COL As Int32 = 5
    Public Const DOWNLOAD_ITEM_STATUS_COL As Int32 = 6
    Public Const DOWNLOAD_ITEM_STATUS_ID_COL As Int32 = 7
    Public Const DOWNLOAD_ITEM_MESSAGE_COL As Int32 = 8
    Public Const DOWNLOAD_ITEM_MAX_COLS As Int32 = 8


    Public Const COL_NAME_DOWNLOAD_ORDER_ID As String = "Id"
    Public Const COL_NAME_DOWNLOAD_PRINT_LOCATION_ID As String = "Print Location Id"
    Public Const COL_NAME_DOWNLOAD_ORDER_STATUS_ID As String = "Order Status Id"
    Public Const COL_NAME_DOWNLOAD_ORDER_STATUS As String = "Order Status"
    Public Const COL_NAME_DOWNLOAD_ORDER_NUMBER As String = "Order Number"
    Public Const COL_NAME_DOWNLOAD_ORDER_NAME As String = "Order Name"
    Public Const COL_NAME_DOWNLOAD_ORDER_LIBRARY_ID As String = "Order Library Id"
    Public Const COL_NAME_DOWNLOAD_ORDER_LIBRARY As String = "Library Connection"
    Public Const COL_NAME_DOWNLOAD_ORDER_PRINT_LOCATION As String = "Print Location"
    Public Const COL_NAME_DOWNLOAD_ORDER_MESSAGE As String = "Message"

    Public Const COL_NAME_DOWNLOAD_ORDER_ITEM_QUEUE_ID As String = "Id"
    Public Const COL_NAME_DOWNLOAD_ORDER_ITEM_ID As String = "Order Item Id"
    Public Const COL_NAME_DOWNLOAD_ORDER_ITEM_PRODUCTION_COMPONENT_ID As String = "Production Component Id"
    Public Const COL_NAME_DOWNLOAD_ORDER_ITEM_ORDER_ID As String = "Order Id"
    Public Const COL_NAME_DOWNLOAD_ORDER_ITEM_LIBRARY_ID As String = "Library Id"
    Public Const COL_NAME_DOWNLOAD_ORDER_ITEM_DISPLAY_NAME As String = "Name"
    Public Const COL_NAME_DOWNLOAD_ORDER_ITEM_STATUS As String = "Status"
    Public Const COL_NAME_DOWNLOAD_ORDER_ITEM_STATUS_ID As String = "Status Id"
    Public Const COL_NAME_DOWNLOAD_ORDER_ITEM_MESSAGE As String = "Message"

    Public Const TABLE_NAME_DOWNLOAD_ORDERS As String = "Orders"
    Public Const TABLE_NAME_DOWNLOAD_ORDER_ITEMS As String = "OrderItems"

    Public Const DOWNLOAD_TABLE_RELATION_NAME As String = "OrdersToItems"

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        InitializeForm()

    End Sub

    Private Sub InitializeForm()

        InitializeQueueSpread()

    End Sub

    Private Sub InitializeQueueSpread()

        Dim dsQueue As DataSet
        Dim dteOrders As DataTable
        Dim dteOrderItems As DataTable
        Dim dtStr As System.Type
        Dim objParentCols(1) As DataColumn
        Dim objChildCols(1) As DataColumn

        Try

            'over kil making sure it is all gone
            'clear rows in spread, if any
            With spdTest.ActiveSheet

                'clear 
                .ClearSelection()
                .ClearRange(0, _
                         DOWNLOAD_ORDER_ID_COL, _
                        spdTest.ActiveSheet.RowCount - 1, _
                        DOWNLOAD_ORDER_MAX_COLS, True)

                'set the new data set as the data source
                If Not .DataSource Is Nothing Then
                    With CType(.DataSource, DataSet)
                        For Each objTable As DataTable In .Tables
                            objTable.Clear()
                            objTable.Dispose()
                        Next
                        .Dispose()
                    End With
                    .Dispose()
                    .DataSource = Nothing
                End If

                .Rows.Count = 0
                .Columns.Count = 0

            End With

            'FARPOINT  - http://www.clubfarpoint.com/Forums/forums/thread/46533.aspx
            '///////////////////////////////////////////////////////////////
            'this should clear any listeners and stop memory leak
            spdTest.Reset()

            System.GC.WaitForPendingFinalizers()
            System.GC.Collect()

            '///////////////////////////////////////////////////////////////

            spdTest.VerticalScrollBarPolicy = ScrollBarPolicy.AsNeeded
            spdTest.HorizontalScrollBarPolicy = ScrollBarPolicy.AsNeeded
            spdTest.ScrollBarShowMax = True
            spdTest.SetCursor(CursorType.Normal, Cursors.Arrow)

            'create empty queue dataset structure
            dsQueue = New DataSet
            dtStr = System.Type.GetType("System.String")
            dsQueue.EnforceConstraints = False

            'create a orders table in the queue dataset
            dteOrders = dsQueue.Tables.Add(TABLE_NAME_DOWNLOAD_ORDERS)

            dteOrders.Columns.AddRange(New DataColumn() _
                        {New DataColumn(COL_NAME_DOWNLOAD_ORDER_ID, dtStr), _
                        New DataColumn(COL_NAME_DOWNLOAD_PRINT_LOCATION_ID, dtStr), _
                        New DataColumn(COL_NAME_DOWNLOAD_ORDER_NUMBER, dtStr), _
                        New DataColumn(COL_NAME_DOWNLOAD_ORDER_NAME, dtStr), _
                        New DataColumn(COL_NAME_DOWNLOAD_ORDER_LIBRARY_ID, dtStr), _
                        New DataColumn(COL_NAME_DOWNLOAD_ORDER_LIBRARY, dtStr), _
                        New DataColumn(COL_NAME_DOWNLOAD_ORDER_PRINT_LOCATION, dtStr), _
                        New DataColumn(COL_NAME_DOWNLOAD_ORDER_STATUS_ID, dtStr), _
                        New DataColumn(COL_NAME_DOWNLOAD_ORDER_STATUS, dtStr)})

            'create a order items table in the queue dataset
            '* this table will be have a relation to the orders table in the queue dataset
            '   1 order can have N order items
            dteOrderItems = dsQueue.Tables.Add(TABLE_NAME_DOWNLOAD_ORDER_ITEMS)

            dteOrderItems.Columns.AddRange(New DataColumn() _
                            {New DataColumn(COL_NAME_DOWNLOAD_ORDER_ITEM_QUEUE_ID, dtStr), _
                            New DataColumn(COL_NAME_DOWNLOAD_ORDER_ITEM_ID, dtStr), _
                            New DataColumn(COL_NAME_DOWNLOAD_ORDER_ITEM_PRODUCTION_COMPONENT_ID, dtStr), _
                            New DataColumn(COL_NAME_DOWNLOAD_ORDER_ITEM_ORDER_ID, dtStr), _
                            New DataColumn(COL_NAME_DOWNLOAD_ORDER_ITEM_LIBRARY_ID, dtStr), _
                            New DataColumn(COL_NAME_DOWNLOAD_ORDER_ITEM_DISPLAY_NAME, dtStr), _
                            New DataColumn(COL_NAME_DOWNLOAD_ORDER_ITEM_STATUS, dtStr), _
                            New DataColumn(COL_NAME_DOWNLOAD_ORDER_ITEM_STATUS_ID, dtStr), _
                            New DataColumn(COL_NAME_DOWNLOAD_ORDER_ITEM_MESSAGE, dtStr)})

            dteOrderItems.DefaultView.AllowNew = False

            objParentCols(0) = dteOrders.Columns(COL_NAME_DOWNLOAD_ORDER_LIBRARY_ID)
            objParentCols(1) = dteOrders.Columns(COL_NAME_DOWNLOAD_ORDER_ID)

            objChildCols(0) = dteOrderItems.Columns(COL_NAME_DOWNLOAD_ORDER_ITEM_LIBRARY_ID)
            objChildCols(1) = dteOrderItems.Columns(COL_NAME_DOWNLOAD_ORDER_ITEM_ORDER_ID)

            'Add the relations
            dsQueue.Relations.Add(DOWNLOAD_TABLE_RELATION_NAME, objParentCols, objChildCols)

            'initialize control structure and attributes
            With spdTest.ActiveSheet
                .OperationMode = OperationMode.ExtendedSelect
                .SelectionUnit = Model.SelectionUnit.Row
                .GrayAreaBackColor = Color.White
                .AlternatingRows(0).BackColor = Color.White
                .AlternatingRows(1).BackColor = Color.WhiteSmoke
                '.AlternatingRows(1).BackColor = Color.FromArgb(237, 243, 254)
                .VerticalGridLine = New GridLine(GridLineType.None)
                .HorizontalGridLine = New GridLine(GridLineType.Flat)
                .RowHeaderAutoText = HeaderAutoText.Blank
                .DataAutoHeadings = False
                .DataAutoCellTypes = False
                .DataAutoSizeColumns = False
                .SetRowSizeable(-1, False)

                .DataSource = dsQueue
                .DataMember = TABLE_NAME_DOWNLOAD_ORDERS
                .RowHeader.Columns(0).Width = 24

                .ColumnCount = DOWNLOAD_ORDER_MAX_COLS + 1
                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_ID_COL, 0, DOWNLOAD_ORDER_MAX_COLS).Font = New Font("Arial", 8, FontStyle.Bold)
                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_ID_COL, 0, DOWNLOAD_ORDER_MAX_COLS).HorizontalAlignment = CellHorizontalAlignment.Left
                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_ID_COL, 0, DOWNLOAD_ORDER_MAX_COLS).VerticalAlignment = CellVerticalAlignment.Center

                .Columns(DOWNLOAD_ORDER_ID_COL).Visible = False
                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_ID_COL).Text = COL_NAME_DOWNLOAD_ORDER_ID
                .Columns(DOWNLOAD_ORDER_ID_COL).CellType = New CellType.TextCellType

                .Columns(DOWNLOAD_ORDER_PRINT_LOCATION_ID_COL).Visible = False
                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_PRINT_LOCATION_ID_COL).Text = COL_NAME_DOWNLOAD_PRINT_LOCATION_ID
                .Columns(DOWNLOAD_ORDER_PRINT_LOCATION_ID_COL).CellType = New CellType.TextCellType


                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_NUMBER_COL).Text = COL_NAME_DOWNLOAD_ORDER_NUMBER
                .Columns(DOWNLOAD_ORDER_NUMBER_COL).Width = 150
                .Columns(DOWNLOAD_ORDER_NUMBER_COL).HorizontalAlignment = CellHorizontalAlignment.Left
                .Columns(DOWNLOAD_ORDER_NUMBER_COL).VerticalAlignment = CellVerticalAlignment.Center
                .Columns(DOWNLOAD_ORDER_NUMBER_COL).CellType = New CellType.TextCellType
                With CType(.Columns(DOWNLOAD_ORDER_NUMBER_COL).CellType, CellType.TextCellType)
                    .Static = True
                End With

                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_NAME_COL).Text = COL_NAME_DOWNLOAD_ORDER_NAME
                .Columns(DOWNLOAD_ORDER_NAME_COL).Width = 175
                .Columns(DOWNLOAD_ORDER_NAME_COL).HorizontalAlignment = CellHorizontalAlignment.Left
                .Columns(DOWNLOAD_ORDER_NAME_COL).VerticalAlignment = CellVerticalAlignment.Center
                .Columns(DOWNLOAD_ORDER_NAME_COL).CellType = New CellType.TextCellType
                With CType(.Columns(DOWNLOAD_ORDER_NAME_COL).CellType, CellType.TextCellType)
                    .Static = True
                End With

                .Columns(DOWNLOAD_ORDER_LIBRARY_ID_COL).Visible = False
                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_LIBRARY_ID_COL).Text = COL_NAME_DOWNLOAD_ORDER_LIBRARY_ID
                .Columns(DOWNLOAD_ORDER_LIBRARY_ID_COL).CellType = New CellType.TextCellType

                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_LIBRARY_COL).Text = COL_NAME_DOWNLOAD_ORDER_LIBRARY
                .Columns(DOWNLOAD_ORDER_LIBRARY_COL).Width = 175
                .Columns(DOWNLOAD_ORDER_LIBRARY_COL).HorizontalAlignment = CellHorizontalAlignment.Left
                .Columns(DOWNLOAD_ORDER_LIBRARY_COL).VerticalAlignment = CellVerticalAlignment.Center
                .Columns(DOWNLOAD_ORDER_LIBRARY_COL).CellType = New CellType.TextCellType
                With CType(.Columns(DOWNLOAD_ORDER_LIBRARY_COL).CellType, CellType.TextCellType)
                    .Static = True
                End With

                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_PRINT_LOCATION_COL).Text = COL_NAME_DOWNLOAD_ORDER_PRINT_LOCATION
                .Columns(DOWNLOAD_ORDER_PRINT_LOCATION_COL).Width = 125
                .Columns(DOWNLOAD_ORDER_PRINT_LOCATION_COL).HorizontalAlignment = CellHorizontalAlignment.Left
                .Columns(DOWNLOAD_ORDER_PRINT_LOCATION_COL).VerticalAlignment = CellVerticalAlignment.Center
                .Columns(DOWNLOAD_ORDER_PRINT_LOCATION_COL).CellType = New CellType.TextCellType
                With CType(.Columns(DOWNLOAD_ORDER_PRINT_LOCATION_COL).CellType, CellType.TextCellType)
                    .Static = True
                End With

                .Columns(DOWNLOAD_ORDER_STATUS_ID_COL).Visible = False
                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_STATUS_ID_COL).Text = COL_NAME_DOWNLOAD_ORDER_STATUS_ID
                .Columns(DOWNLOAD_ORDER_STATUS_ID_COL).CellType = New CellType.TextCellType

                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_STATUS_COL).Text = COL_NAME_DOWNLOAD_ORDER_STATUS
                .Columns(DOWNLOAD_ORDER_STATUS_COL).Width = 150
                .Columns(DOWNLOAD_ORDER_STATUS_COL).HorizontalAlignment = CellHorizontalAlignment.Left
                .Columns(DOWNLOAD_ORDER_STATUS_COL).VerticalAlignment = CellVerticalAlignment.Center
                .Columns(DOWNLOAD_ORDER_STATUS_COL).CellType = New CellType.TextCellType
                With CType(.Columns(DOWNLOAD_ORDER_STATUS_COL).CellType, CellType.TextCellType)
                    .Static = True
                End With

                .ColumnHeader.Cells(0, DOWNLOAD_ORDER_MESSAGE_COL).Text = COL_NAME_DOWNLOAD_ORDER_MESSAGE
                .Columns(DOWNLOAD_ORDER_MESSAGE_COL).Width = 287
                .Columns(DOWNLOAD_ORDER_MESSAGE_COL).HorizontalAlignment = CellHorizontalAlignment.Left
                .Columns(DOWNLOAD_ORDER_MESSAGE_COL).VerticalAlignment = CellVerticalAlignment.Center
                .Columns(DOWNLOAD_ORDER_MESSAGE_COL).CellType = New CellType.TextCellType
                With CType(.Columns(DOWNLOAD_ORDER_MESSAGE_COL).CellType, CellType.TextCellType)
                    .Static = True
                End With

                .Columns(DOWNLOAD_ORDER_MAX_COLS).Border = New FarPoint.Win.ComplexBorder(Nothing, Nothing, New FarPoint.Win.ComplexBorderSide(Color.Gainsboro), Nothing)

            End With

        Finally
            dsQueue = Nothing
        End Try

    End Sub

    Private Sub LoadExistingQueueItems()

        Dim dteOrders As DataTable = Nothing
        Dim dteOrderItems As DataTable = Nothing
        Dim objChildSheet As FarPoint.Win.Spread.SheetView = Nothing

        Dim lngId As Int64
        Dim strOrderId As String
        Dim strPrintLocationId As String
        Dim lngOrderNumber As Int64
        Dim strOrderName As String
        Dim strLibraryId As String
        Dim strLibraryName As String
        Dim strPrintLocationName As String
        Dim strStatus As String
        Dim intStatus As Int32
        Dim eStatus As Int32
        Dim strOrderItemId As String
        Dim strProductionComponentId As String
        Dim strDisplayName As String
        Dim strMessage As String


        Try

            spdTest.SuspendLayout()

            InitializeQueueSpread()

            'get tables from queue dataset
            dteOrders = CType(spdTest.DataSource, DataSet).Tables(TABLE_NAME_DOWNLOAD_ORDERS)
            dteOrderItems = CType(spdTest.DataSource, DataSet).Tables(TABLE_NAME_DOWNLOAD_ORDER_ITEMS)

            strLibraryId = "A"

            'load each queue item
            For i As Int32 = 0 To 100

                lngId = i
                strOrderId = i.ToString
                strPrintLocationId = i.ToString
                lngOrderNumber = i
                strOrderName = i.ToString
                strLibraryName = i.ToString
                strPrintLocationName = i.ToString
                intStatus = i
                eStatus = i
                strStatus = i.ToString
                strOrderItemId = i.ToString
                strProductionComponentId = i.ToString
                strDisplayName = i.ToString
                strMessage = i.ToString

                'new order add order row to table
                dteOrders.Rows.Add(New Object() {strOrderId, _
                                                        strPrintLocationId, _
                                                        lngOrderNumber, _
                                                        strOrderName, _
                                                        strLibraryId, _
                                                        strLibraryName, _
                                                        strPrintLocationName, _
                                                        intStatus, _
                                                        strStatus})

                For x As Int32 = 0 To 50

                    'add order item row
                    dteOrderItems.Rows.Add(New Object() {lngId, _
                                                            strOrderItemId, _
                                                            strProductionComponentId, _
                                                            strOrderId, _
                                                            strLibraryId, _
                                                            x.ToString, _
                                                            strStatus, _
                                                            intStatus, _
                                                            strMessage})

                Next


            Next

            'its all loaded now lets update statuses
            With spdTest.ActiveSheet

                For i As Int32 = 0 To .Rows.Count - 1

                    '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                    'MEMORY LEAK - whatch your private bytes rise
                    ' each cycle allocates more
                    '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
                    'get the order items
                    objChildSheet = spdTest.ActiveSheet.GetChildView(i, 0)

                    'KILLING OBJECT DOES NOT DISPOSE OF LISTNERS IN PARENT
                    If objChildSheet IsNot Nothing Then objChildSheet.Dispose()
                    objChildSheet = Nothing

                Next

            End With

        Finally

            If dteOrders IsNot Nothing Then dteOrders.Dispose()
            dteOrders = Nothing
            If dteOrderItems IsNot Nothing Then dteOrderItems.Dispose()
            dteOrderItems = Nothing
            If objChildSheet IsNot Nothing Then objChildSheet.Dispose()
            objChildSheet = Nothing

            spdTest.ResumeLayout()

        End Try

    End Sub


    Private Sub btnCycle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCycle.Click

        Try
            System.Windows.Forms.Cursor.Current = Cursors.WaitCursor

            LoadExistingQueueItems()

        Catch ex As Exception
            MessageBox.Show(ex.Message & System.Environment.NewLine & System.Environment.NewLine, ex.StackTrace)

        Finally
            System.Windows.Forms.Cursor.Current = Cursors.Default

        End Try

    End Sub

End Class
